/*
 * USART.cpp
 *
 *  Created on: 25.03.2009
 *      Author: Xaos
 */

#include "USART.h"
#include <avr/io.h>



/**
 * KONSTRUKTOR
 * @param int baudrate
 * @param int serielChannel (0|1)
 */
USART::USART (int chan){
	unsigned int ubbr = 103;

	if (chan==0){

			DDRE = 0xFF;
			PORTE = 0;
			DDRE = 0;
			DDRE  |= (1<<DDE1)|(1<<DDE2);

			UBRR0H = (ubbr>>8);
			UBRR0L = ubbr;
			//UBRR0H = (uint8_t) ((F_CPU/(baudrate*16)-1)>>8);
			//UBRR0L = (uint8_t)  (F_CPU/(baudrate*16)-1);

			// enable receiver and transmitter
			UCSR0B = (1<<RXEN0)|(1<<TXEN0);
			// 1 stop bit
			UCSR0C = (0<<USBS0);
			// 8Bit Data
			UCSR0C |= (1<<UCSZ01)|(1<<UCSZ00)|(0<<UCSZ02);
			// Parity Disabled
			UCSR0C |= (0<<UPM01)|(0<<UPM00);
	};

	if (chan==1){

//				UBRR1H = (103>>8);
//				UBRR1L = 103;

		//UBRR0H = (uint8_t) ((F_CPU/(baudrate*16)-1)>>8);
		//UBRR0L = (uint8_t)  (F_CPU/(baudrate*16)-1);

		// enable receiver and transmitter
		UCSR1B = (1<<RXEN0)|(1<<TXEN0);
		// 1 stop bit
		//UCSR1C = (0<<USBS1);
		// 8Bit Data
		//UCSR1C |= (1<<UCSZ11)|(1<<UCSZ10)|(0<<UCSZ12);
		// Parity Disabled
		//UCSR1C |= (0<<UPM11)|(0<<UPM10);


	};


};
int USART::getChannel(){
	return this->channel;
};


void USART::write(unsigned char data){
	while ( !( UCSR0A & (1<<UDRE0)) )
	;
	UDR0 = data;
};





