#include <avr/io.h>
#include <util/delay.h>
#include <avr/interrupt.h>
#include <inttypes.h>
#include <stdio.h>

#include "bimaq/String.h"
#include "bimaq/io/USART.h"


/** C++ **************************************************/
#if defined (__cplusplus)
	extern "C" {
#endif
/** C++ **************************************************/



/**
 * MAIN
 */
int main(void){
	   DDRB=0xFF;

	   String test;
	   test ="HelloWorld";

	   USART chan0 (0);

	   // print string
	   for (int i=0;i<test.length();i++){
		   chan0.write(test.getChar(i));
	   }

	   // print test output
	   chan0.write(test.getChar(0));
	   chan0.write(test.getChar(1));
	   chan0.write(test.getChar(2));
	   chan0.write(test.length()+97);
	   chan0.write(test.getChar(1));
	   chan0.write(test.getChar(2));

	   // led tog
	   for(;;){
	      PORTB=0xFF;
	      chan0.write('.');
	      _delay_ms(100);
	      PORTB=0x00;
	      _delay_ms(100);
	   }
};


/** C++ **************************************************/
#if defined (__cplusplus)
};
#endif
/** C++ **************************************************/



